/**
 * @template Value
 */
export class FindUp<Value> {
    /**
     * @callback Create
     * @param {Buffer} buf
     * @param {string} filePath
     * @returns {Promise<Value|undefined>|Value|undefined}
     */
    /**
     * @callback Callback
     * @param {Error|null} error
     * @param {Value} [result]
     * @returns {void}
     */
    /**
     * @typedef Options
     * @property {string} cwd
     * @property {string|undefined} filePath
     * @property {boolean|undefined} [detect]
     * @property {string[]} names
     * @property {Create} create
     */
    /**
     * @param {Options} options
     */
    constructor(options: {
        cwd: string;
        filePath: string | undefined;
        detect?: boolean | undefined;
        names: string[];
        create: (buf: Buffer, filePath: string) => Promise<Value | undefined> | Value | undefined;
    });
    /** @type {Record<string, Callback[]|undefined|Error|Value>} */
    cache: Record<string, Value | Error | ((error: Error | null, result?: Value | undefined) => void)[] | undefined>;
    /** @type {string} */
    cwd: string;
    /** @type {boolean|undefined} */
    detect: boolean | undefined;
    /** @type {string[]} */
    names: string[];
    /** @type {Create} */
    create: (buf: Buffer, filePath: string) => Promise<Value | undefined> | Value | undefined;
    /** @type {string|undefined} */
    givenFilePath: string | undefined;
    /** @type {Error|Value|Callback[]|undefined} */
    givenFile: Value | Error | ((error: Error | null, result?: Value | undefined) => void)[] | undefined;
    /**
     * @param {string} filePath
     * @param {Callback} callback
     */
    load(filePath: string, callback: (error: Error | null, result?: Value | undefined) => void): void;
}
